## xdp-tools 1.2.6

=== debian/changelog ===
xdp-tools (1.2.6-2) unstable; urgency=medium

  * Do not build-depend on gcc-multilib and instead export
    -I/usr/include/<multiarch> for asm/types.h
  * Export __MIPSEL__=1 to Clang on mipsel*

 -- Luca Boccassi <bluca@debian.org>  Sat, 20 Aug 2022 16:17:21 +0100

xdp-tools (1.2.6-1) unstable; urgency=medium

  * Do not depend on gcc-multilib on architectures where it's not
    available
  * d/copyright: rearrange stanzas
  * Update upstream source from tag 'upstream/1.2.6'
  * Drop patches, all merged upstream

 -- Luca Boccassi <bluca@debian.org>  Sat, 20 Aug 2022 02:55:59 +0100

xdp-tools (1.2.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1015880)

 -- Luca Boccassi <bluca@debian.org>  Sun, 24 Jul 2022 22:45:17 +0100

=== debian/watch ===
version=4
https://github.com/xdp-project/xdp-tools/releases .*/v\d.+/xdp-tools-([\d\.]+)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## xdp-tools 1.3.0

=== xdp-bench/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS := xdp_redirect_basic.bpf xdp_redirect_cpumap.bpf xdp_redirect_devmap.bpf \
	       xdp_redirect_devmap_multi.bpf xdp_basic.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-bench
MAN_PAGE := xdp-bench.8
TEST_FILE := tests/test-xdp-bench.sh
USER_TARGETS := xdp-bench
USER_LIBS     = -lm
USER_EXTRA_C := xdp_redirect_basic.c xdp_redirect_cpumap.c xdp_redirect_devmap.c \
		xdp_redirect_devmap_multi.c xdp_basic.c
EXTRA_USER_DEPS := xdp-bench.h

LIB_DIR       = ../lib

include $(LIB_DIR)/common.mk

=== xdp-monitor/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS := xdp_monitor.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-monitor
MAN_PAGE := xdp-monitor.8
TEST_FILE := tests/test-xdp-monitor.sh
USER_TARGETS := xdp-monitor
LIB_DIR       = ../lib
USER_LIBS     = -lm

include $(LIB_DIR)/common.mk

## xdp-tools 1.2.8

=== debian/changelog ===
xdp-tools (1.2.8-1ppa1~noble3) noble; urgency=medium

  * debian/patches: Restructure for upstream tracking

 -- Yep, Mun Chun <mun.chun.yep@intel.com>  Fri, 24 Oct 2025 20:13:37 +0800

xdp-tools (1.2.8-1ppa1~noble2) noble; urgency=medium

  * debian/control: Update libbpf-dev build dependencies

 -- Tan Khai Wen <khai.wen.tan@intel.com> Mon, 27 Oct 2024 12:00:17 +0800

xdp-tools (1.2.8-1ppa1~noble1) noble; urgency=medium

  * build for ubuntu 24.04 

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 24 Apr 2024 15:17:33 +0800

xdp-tools (1.2.8-1ppa1~jammy1) jammy; urgency=medium

  * Initial release 1.2.8 for Ubuntu Jammy.

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 08 Nov 2023 12:47:52 +0800

=== debian/control ===
Source: xdp-tools
Section: devel
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Rules-Requires-Root: no
Build-Depends: clang,
               debhelper-compat (= 13),
               libbpf-dev (>= 0.7.0-1ppa1~noble1),
               libelf-dev,
               libpcap-dev,
               llvm,
               pkg-config,
               zlib1g-dev,
Standards-Version: 4.6.1
Homepage: https://github.com/xdp-project/xdp-tools
Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git

Package: libxdp1
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: library and utilities for use with XDP - shared library
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.

Package: libxdp-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libxdp1 (= ${binary:Version}), ${misc:Depends},
Description: library and utilities for use with XDP - development files
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides the development files for libxdp1.

Package: xdp-tools
Architecture: linux-any
Depends: libxdp1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Description: library and utilities for use with XDP
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides tools for the xdp ecosystem.

Package: xdp-tests
Architecture: linux-any
Depends: xdp-tools (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Description: library and utilities for use with XDP - test scripts and programs
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides tests for the xdp tools.

## xdp-tools 1.2.9

=== debian/changelog ===
xdp-tools (1.2.9-2) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2, no changes
  * Bump copyright year ranges in d/copyright
  * libxdp-dev: depend on libbpf-dev for pkgconfig's Requires.private

 -- Luca Boccassi <bluca@debian.org>  Fri, 13 Jan 2023 10:29:31 +0000

xdp-tools (1.2.9-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.9'

 -- Luca Boccassi <bluca@debian.org>  Wed, 14 Dec 2022 23:17:25 +0000

xdp-tools (1.2.8-1) unstable; urgency=medium

  * d/watch: use api.github.com
  * Update upstream source from tag 'upstream/1.2.8'

 -- Luca Boccassi <bluca@debian.org>  Sat, 12 Nov 2022 00:21:06 +0000

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Rules-Requires-Root: no
 Build-Depends: clang,
                debhelper-compat (= 13),
-               libbpf-dev (>= 0.7.0-1ppa1~noble1),
+               libbpf-dev,
                libelf-dev,
                libpcap-dev,
                llvm,
                pkg-config,
                zlib1g-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/xdp-project/xdp-tools
 Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
 Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git
@@ -30,7 +30,7 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends: libxdp1 (= ${binary:Version}), ${misc:Depends},
+Depends: libxdp1 (= ${binary:Version}), ${misc:Depends}, libbpf-dev,
 Description: library and utilities for use with XDP - development files
  Library for working with the eXpress Data Path facility of the Linux kernel,
  and a collection of utilities and example code that uses the library.

## xdp-tools 1.3.0

=== debian/changelog ===
xdp-tools (1.3.0-2ubuntu2) lunar; urgency=medium

  * d/p/lp-2008214-ppc64le-build-failure.patch: Resolve FTBFS for ppc64le on
    Ubuntu (LP: #2008214).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Thu, 23 Feb 2023 14:02:56 +0100

xdp-tools (1.3.0-2ubuntu1) lunar; urgency=medium

  * Resolve FTBFS on Ubuntu (LP: #2007308):
    - d/control: Change build dep for bpftool on Ubuntu.
    - d/rules: Conditionally set BPFTOOL variable for build on Ubuntu.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Wed, 22 Feb 2023 15:12:51 +0000

xdp-tools (1.3.0-2) unstable; urgency=medium

  * Add patch to fix build on arm/mips

 -- Luca Boccassi <bluca@debian.org>  Sun, 12 Feb 2023 13:47:23 +0000

xdp-tools (1.3.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.3.0'
  * Add build dependency on bpftool
  * Install new tools
  * Update symbols file
  * Drop unused Lintian override

 -- Luca Boccassi <bluca@debian.org>  Sat, 11 Feb 2023 12:29:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: xdp-tools
 Section: devel
 Priority: optional
-Maintainer: Luca Boccassi <bluca@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Luca Boccassi <bluca@debian.org>
 Rules-Requires-Root: no
 Build-Depends: clang,
                debhelper-compat (= 13),
                libbpf-dev,
                libelf-dev,
                libpcap-dev,
+               linux-tools-generic,
                llvm,
                pkg-config,
                zlib1g-dev,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
export FORCE_SYSTEM_LIBBPF=1
export PRODUCTION=1
# For asm/types.h
export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
export BPF_CFLAGS+= -D__MIPSEL__=1
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
# the binary corresponding to runtime kernel version.
#
# We do not know the kernel version being used on the system building
# this package, and for the build we only need the tool to generate
# skeleton code.
#
# If /usr/lib/linux-tools/*/bpftool exists, locate the most recent
# version and point to that, otherwise `bpftool` from PATH will be
# used.
export BPFTOOL=$(shell find /usr/lib/linux-tools -name bpftool -executable -print | sort -nr | head -1)
endif

%:
	dh $@

# Tests require root and break the testbed
override_dh_auto_test:

## xdp-tools 1.3.1

=== Makefile ===

# SPDX-License-Identifier: GPL-2.0
# Top level Makefile for xdp-tools

ifeq ("$(origin V)", "command line")
VERBOSE = $(V)
endif
ifndef VERBOSE
VERBOSE = 0
endif

ifeq ($(VERBOSE),0)
MAKEFLAGS += --no-print-directory
endif

include version.mk

UTILS := xdp-filter xdp-loader xdp-dump xdp-bench xdp-monitor xdp-trafficgen
SUBDIRS := lib $(UTILS)
.PHONY: check_submodule help clobber distclean clean install test libxdp $(SUBDIRS)

all: $(SUBDIRS)

lib: config.mk check_submodule
	@echo; echo $@; $(MAKE) -C $@

libxdp: config.mk check_submodule
	@echo; echo lib; $(MAKE) -C lib $@

libxdp_install: libxdp
	@$(MAKE) -C lib $@

$(UTILS): lib
	@echo; echo $@; $(MAKE) -C $@

help:
	@echo "Make Targets:"
	@echo " all                 - build binaries"
	@echo " clean               - remove products of build"
	@echo " distclean           - remove configuration and build"
	@echo " install             - install binaries on local machine"
	@echo " test                - run test suite"
	@echo " archive             - create tarball of all sources"
	@echo ""
	@echo "Make Arguments:"
	@echo " V=[0|1]             - set build verbosity level"

config.mk: configure
	sh configure

check_submodule:
	@if [ -d .git ] && `git submodule status lib/libbpf | grep -q '^+'`; then \
		echo "" ;\
		echo "** WARNING **: git submodule SHA-1 out-of-sync" ;\
		echo " consider running: git submodule update"  ;\
		echo "" ;\
	fi\

clobber:
	touch config.mk
	$(MAKE) clean
	rm -f config.mk cscope.* compile_commands.json

distclean: clobber

clean: check_submodule
	@for i in $(SUBDIRS); \
	do $(MAKE) -C $$i clean; done

install: all
	@for i in $(SUBDIRS); \
	do $(MAKE) -C $$i install; done

test: all
	@for i in lib/libxdp $(UTILS); do \
		echo; echo test $$i; $(MAKE) -C $$i test; \
		if [ $$? -ne 0 ]; then failed="y"; fi; \
	done; \
	if [ ! -z $$failed ]; then exit 1; fi


archive: xdp-tools-$(TOOLS_VERSION).tar.gz

.PHONY: xdp-tools-$(TOOLS_VERSION).tar.gz
xdp-tools-$(TOOLS_VERSION).tar.gz:
	@./mkarchive.sh "$(TOOLS_VERSION)"

compile_commands.json: clean
	compiledb make V=1

=== lib/libxdp/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

LIB_DIR = ..

include libxdp.mk
include $(LIB_DIR)/defines.mk

OBJDIR ?= .
SHARED_OBJDIR := $(OBJDIR)/sharedobjs
STATIC_OBJDIR := $(OBJDIR)/staticobjs
OBJS := libxdp.o xsk.o
XDP_OBJS := xdp-dispatcher.o xsk_def_xdp_prog.o xsk_def_xdp_prog_5.3.o
EMBEDDED_XDP_OBJS := $(addsuffix .embed.o,$(basename $(XDP_OBJS)))
SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS)) $(EMBEDDED_XDP_OBJS)
STATIC_LIBS := $(OBJDIR)/libxdp.a
MAN_PAGE := libxdp.3
MAN_OBJ := ${MAN_PAGE:.3=.man}
MAN_FILES := $(MAN_PAGE)
TEST_DIR := tests

SHARED_CFLAGS += -fPIC -DSHARED
LIB_HEADERS := $(wildcard $(HEADER_DIR)/xdp/*.h)
BPF_HEADERS := $(wildcard $(HEADER_DIR)/bpf/*.h) $(wildcard $(HEADER_DIR)/xdp/*.h)
EXTRA_LIB_DEPS := $(OBJECT_LIBBPF) $(LIBMK) $(LIB_OBJS) $(LIB_HEADERS) compat.h libxdp_internal.h xsk_def_xdp_prog.h bpf_instr.h
PC_FILE := $(OBJDIR)/libxdp.pc
TEMPLATED_SOURCES := xdp-dispatcher.c

CFLAGS += -I$(HEADER_DIR)
BPF_CFLAGS += -I$(HEADER_DIR)


ifndef BUILD_STATIC_ONLY
SHARED_LIBS := $(OBJDIR)/libxdp.so \
	       $(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION) \
	       $(OBJDIR)/libxdp.so.$(LIBXDP_VERSION)
VERSION_SCRIPT := libxdp.map
CHECK_RULES := check_abi
endif

all: $(STATIC_LIBS) $(SHARED_LIBS) $(XDP_OBJS) $(PC_FILE) check man

clean:
	$(Q)rm -f $(STATIC_LIBS) $(STATIC_OBJS) $(SHARED_LIBS) $(SHARED_OBJS) $(XDP_OBJS) $(PC_FILE) $(MAN_OBJ) $(TEMPLATED_SOURCES)
	$(Q)for d in $(SHARED_OBJDIR) $(STATIC_OBJDIR); do \
		[ -d "$$d" ] && rmdir "$$d"; done || true
	$(Q)$(MAKE) -C $(TEST_DIR) clean

install: all
	$(Q)install -d -m 0755 $(DESTDIR)$(HDRDIR)
	$(Q)install -d -m 0755 $(DESTDIR)$(LIBDIR)
	$(Q)install -d -m 0755 $(DESTDIR)$(LIBDIR)/pkgconfig
	$(Q)install -d -m 0755 $(DESTDIR)$(BPF_OBJECT_DIR)
	$(Q)install -m 0644 $(LIB_HEADERS) $(DESTDIR)$(HDRDIR)/
	$(Q)install -m 0644 $(PC_FILE) $(DESTDIR)$(LIBDIR)/pkgconfig/
	$(Q)cp -fpR $(SHARED_LIBS) $(STATIC_LIBS) $(DESTDIR)$(LIBDIR)
	$(Q)install -m 0755 $(XDP_OBJS) $(DESTDIR)$(BPF_OBJECT_DIR)
	$(if $(MAN_FILES),$(Q)install -m 0755 -d $(DESTDIR)$(MANDIR)/man3)
	$(if $(MAN_FILES),$(Q)install -m 0644 $(MAN_FILES) $(DESTDIR)$(MANDIR)/man3)


$(OBJDIR)/libxdp.a: $(STATIC_OBJS)
	$(QUIET_LINK)$(AR) rcs $@ $^

$(OBJDIR)/libxdp.so: $(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION): $(OBJDIR)/libxdp.so.$(LIBXDP_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libxdp.so.$(LIBXDP_VERSION): $(SHARED_OBJS)
	$(QUIET_LINK)$(CC) -shared -Wl,-soname,libxdp.so.$(LIBXDP_MAJOR_VERSION) \
		      -Wl,--version-script=$(VERSION_SCRIPT) \
		      $^ $(LDFLAGS) $(LDLIBS) -o $@

$(OBJDIR)/libxdp.pc:
	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
			-e "s|@LIBDIR@|$(LIBDIR)|" \
			-e "s|@VERSION@|$(TOOLS_VERSION)|" \
			< libxdp.pc.template > $@

$(STATIC_OBJDIR):
	$(Q)mkdir -p $(STATIC_OBJDIR)

$(SHARED_OBJDIR):
	$(Q)mkdir -p $(SHARED_OBJDIR)

$(STATIC_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(STATIC_OBJDIR)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) -D LIBXDP_STATIC=1 -Wall -I../../headers -c $< -o $@

$(SHARED_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(SHARED_OBJDIR)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(SHARED_CFLAGS) -Wall -I../../headers -c $< -o $@

XDP_IN_SHARED	:= $(SHARED_OBJDIR)/libxdp.o $(SHARED_OBJDIR)/xsk.o

GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(XDP_IN_SHARED) | \
			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
			   sed 's/\[.*\]//' | \
			   awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
			   sort -u | wc -l)
VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OBJDIR)/libxdp.so | \
			      grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 | sort -u | wc -l)

check: $(CHECK_RULES)

check_abi: $(OBJDIR)/libxdp.so
	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
		echo "Warning: Num of global symbols in $(XDP_IN_SHARED)"	 \
		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
		     "Please make sure all symbols are"	 \
		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
		readelf -s --wide $(XDP_IN_SHARED) |			 \
		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
		    sed 's/\[.*\]//' |					 \
		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
		    sort -u > $(OUTPUT)libxdp_global_syms.tmp;		 \
		readelf --dyn-syms --wide $(OUTPUT)libxdp.so |		 \
		    grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 |		 \
		    sort -u > $(OUTPUT)libxdp_versioned_syms.tmp; 	 \
		diff -u $(OUTPUT)libxdp_global_syms.tmp			 \
		     $(OUTPUT)libxdp_versioned_syms.tmp;		 \
		rm $(OUTPUT)libxdp_global_syms.tmp			 \
		   $(OUTPUT)libxdp_versioned_syms.tmp;			 \
		exit 1;							 \
	fi


$(TEMPLATED_SOURCES): %.c: %.c.in Makefile
	$(QUIET_M4)$(M4) $(DEFINES) $< > $@ || ( ret=$$?; rm -f $@; exit $$ret )

$(EMBEDDED_XDP_OBJS): %.embed.o: %.o
	$(QUIET_GEN)$(LD) -r -b binary -o $@ -z noexecstack --format=binary $<
	$(Q)$(OBJCOPY)  --rename-section .data=.rodata,alloc,load,readonly,data,contents $@

$(XDP_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK)
	$(QUIET_CLANG)$(CLANG) -S \
	    -target $(BPF_TARGET) \
	    -D __BPF_TRACING__ \
	    $(BPF_CFLAGS) \
	    -Wall \
	    -Wno-unused-value \
	    -Wno-pointer-sign \
	    -Wno-compare-distinct-pointer-types \
	    -Werror \
	    -O2 -emit-llvm -c -g -o ${@:.o=.ll} $<
	$(QUIET_LLC)$(LLC) -march=$(BPF_TARGET) -filetype=obj -o $@ ${@:.o=.ll}

.PHONY: man
ifeq ($(EMACS),)
man: ;
else
man: $(MAN_PAGE)
$(MAN_OBJ): README.org $(LIBMK)
	$(Q)$(EMACS) -Q --batch --find-file $< --eval "(progn (require 'ox-man)(org-man-export-to-man))"
	$(Q)touch -r $< $@

$(MAN_PAGE): $(MAN_OBJ) $(LIBMK)
	$(QUIET_GEN)MODDATE=$$(git log -1 --pretty="format:%cI" README.org 2>/dev/null); \
		[ "$$?" -eq "0" ] && DATE=$$(date '+%B %_d, %Y' -d "$$MODDATE") || DATE=$$(date '+%B %_d, %Y'); \
		sed -e "1 s/DATE/$$DATE/" -e "1 s/VERSION/v$(TOOLS_VERSION)/" -e '1,5 s/^.SH "\([^"]\+\) - \([^"]\+\)"/.SH "NAME"\n\1 \\- \2\n.SH "SYNOPSIS"/' $< > $@

endif

.PHONY: test
test: all
	$(Q)$(MAKE) -C $(TEST_DIR) run

=== lib/libxdp/tests/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

USER_TARGETS := test_xsk_refcnt check_kern_compat test_xdp_frags test_dispatcher_versions
BPF_TARGETS := xdp_dispatcher_v1 xdp_pass
USER_LIBS := -lpthread

EXTRA_DEPS += xdp_dispatcher_v1.h
EXTRA_USER_DEPS += test_utils.h

TEST_FILE := ./test-libxdp.sh
TEST_RUNNER := ./test_runner.sh

USER_C := ${USER_TARGETS:=.c}
USER_OBJ := ${USER_C:.c=.o}
BPF_OBJS := $(BPF_TARGETS:=.o)

LIB_DIR := ../..
LDLIBS += $(USER_LIBS)

include $(LIB_DIR)/defines.mk

LDFLAGS+=-L$(LIBXDP_DIR)
ifeq ($(DYNAMIC_LIBXDP),1)
	LDLIBS:=-lxdp $(LDLIBS)
	OBJECT_LIBXDP:=$(LIBXDP_DIR)/libxdp.so.$(LIBXDP_VERSION)
else
	LDLIBS:=-l:libxdp.a $(LDLIBS)
	OBJECT_LIBXDP:=$(LIBXDP_DIR)/libxdp.a
endif

# Detect submodule libbpf source file changes
ifeq ($(SYSTEM_LIBBPF),n)
	LIBBPF_SOURCES := $(wildcard $(LIBBPF_DIR)/src/*.[ch])
endif

LIBXDP_SOURCES := $(wildcard $(LIBXDP_DIR)/*.[ch] $(LIBXDP_DIR)/*.in)

CFLAGS += -I$(HEADER_DIR)

BPF_HEADERS := $(wildcard $(HEADER_DIR)/bpf/*.h) $(wildcard $(HEADER_DIR)/xdp/*.h)

all: $(USER_TARGETS) $(BPF_OBJS)

.PHONY: clean
clean::
	$(Q)rm -f $(USER_TARGETS) $(USER_OBJ)

$(OBJECT_LIBBPF): $(LIBBPF_SOURCES)
	$(Q)$(MAKE) -C $(LIB_DIR) libbpf

$(OBJECT_LIBXDP): $(LIBXDP_SOURCES)
	$(Q)$(MAKE) -C $(LIBXDP_DIR)

# Create expansions for dependencies
LIB_H := ${LIB_OBJS:.o=.h}

# Detect if any of common obj changed and create dependency on .h-files
$(LIB_OBJS): %.o: %.c %.h $(LIB_H)
	$(Q)$(MAKE) -C $(dir $@) $(notdir $@)

ALL_EXEC_TARGETS=$(USER_TARGETS)
$(ALL_EXEC_TARGETS): %: %.c  $(OBJECT_LIBBPF) $(OBJECT_LIBXDP) $(LIBMK) $(LIB_OBJS) $(EXTRA_DEPS) $(EXTRA_USER_DEPS)
	$(QUIET_CC)$(CC) -Wall $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $(LIB_OBJS) \
	 $< $(LDLIBS)

$(BPF_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK) $(EXTRA_DEPS)
	$(QUIET_CLANG)$(CLANG) -S \
	    -target $(BPF_TARGET) \
	    -D __BPF_TRACING__ \
	    $(BPF_CFLAGS) \
	    -Wall \
	    -Wno-unused-value \
	    -Wno-pointer-sign \
	    -Wno-compare-distinct-pointer-types \
	    -Werror \
	    -O2 -emit-llvm -c -g -o ${@:.o=.ll} $<
	$(QUIET_LLC)$(LLC) -march=$(BPF_TARGET) -filetype=obj -o $@ ${@:.o=.ll}

run: all
	$(Q)env CC="$(CC)" CFLAGS="$(CFLAGS) $(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDLIBS="$(LDLIBS)" V=$(V) $(TEST_RUNNER) $(TEST_FILE) $(RUN_TESTS)

=== debian/changelog ===
xdp-tools (1.3.1-1) unstable; urgency=medium

  * Revert "d/control: Add conditional build dep to allow building on
    Ubuntu."
  * Update upstream source from tag 'upstream/1.3.1'
  * Drop libm.patch, merged upstream
  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Sat, 25 Feb 2023 19:59:15 +0000

xdp-tools (1.3.0-3~exp1) experimental; urgency=medium

  [ Frode Nordahl ]
  * d/control: Add conditional build dep to allow building on Ubuntu.
  * d/rules: Conditionally set BPFTOOL variable for build.

 -- Luca Boccassi <bluca@debian.org>  Tue, 21 Feb 2023 15:58:46 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
export FORCE_SYSTEM_LIBBPF=1
export PRODUCTION=1
# For asm/types.h
export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
export BPF_CFLAGS+= -D__MIPSEL__=1
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

%:
	dh $@

# Tests require root and break the testbed
override_dh_auto_test:

execute_before_dh_auto_build:
	# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
	# the binary corresponding to runtime kernel version.
	#
	# We do not know the kernel version being used on the system building
	# this package, and for the build we only need the tool to generate
	# skeleton code.
	#
	# If /usr/lib/linux-tools-*/bpftool exists, locate the most recent
	# version and point to that, otherwise `bpftool` from PATH will be
	# used.
	for _bpftool in $(ls /usr/lib/linux-tools-*/bpftool); do true;done
	if [ -x "$_bpftool" ]; then export BPFTOOL=$_bpftool; fi

## xdp-tools 1.4.2

=== Makefile ===
--- 
+++ 
@@ -14,8 +14,14 @@
 endif
 
 include version.mk
+include config.mk
 
-UTILS := xdp-filter xdp-loader xdp-dump xdp-bench xdp-monitor xdp-trafficgen
+UTILS := xdp-filter xdp-loader xdp-dump
+
+ifneq ($(BPFTOOL),)
+UTILS += xdp-bench xdp-monitor xdp-trafficgen
+endif
+
 SUBDIRS := lib $(UTILS)
 .PHONY: check_submodule help clobber distclean clean install test libxdp $(SUBDIRS)

=== xdp-dump/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
TOOL_NAME    := xdpdump
XDP_TARGETS  := xdpdump_bpf xdpdump_xdp
USER_TARGETS := xdpdump
TEST_FILE    := tests/test-xdpdump.sh

# Disable warnings about VLAs not being at the end of a structure when building
# with clang. The code is fine, but clang's complaint coupled with -Werror would
# break the build. See https://github.com/xdp-project/xdp-tools/issues/304
CFLAGS       += "-Wno-gnu-variable-sized-type-not-at-end"
LIB_DIR       = ../lib
USER_LIBS     = -lpcap
MAN_PAGE     := xdpdump.8

include $(LIB_DIR)/common.mk

=== lib/libxdp/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 TEST_DIR := tests
 
 SHARED_CFLAGS += -fPIC -DSHARED
+STATIC_CFLAGS += -D LIBXDP_STATIC=1
 LIB_HEADERS := $(wildcard $(HEADER_DIR)/xdp/*.h)
 BPF_HEADERS := $(wildcard $(HEADER_DIR)/bpf/*.h) $(wildcard $(HEADER_DIR)/xdp/*.h)
 EXTRA_LIB_DEPS := $(OBJECT_LIBBPF) $(LIBMK) $(LIB_OBJS) $(LIB_HEADERS) compat.h libxdp_internal.h xsk_def_xdp_prog.h bpf_instr.h
@@ -54,7 +55,7 @@
 	$(Q)install -m 0644 $(LIB_HEADERS) $(DESTDIR)$(HDRDIR)/
 	$(Q)install -m 0644 $(PC_FILE) $(DESTDIR)$(LIBDIR)/pkgconfig/
 	$(Q)cp -fpR $(SHARED_LIBS) $(STATIC_LIBS) $(DESTDIR)$(LIBDIR)
-	$(Q)install -m 0755 $(XDP_OBJS) $(DESTDIR)$(BPF_OBJECT_DIR)
+	$(Q)install -m 0644 $(XDP_OBJS) $(DESTDIR)$(BPF_OBJECT_DIR)
 	$(if $(MAN_FILES),$(Q)install -m 0755 -d $(DESTDIR)$(MANDIR)/man3)
 	$(if $(MAN_FILES),$(Q)install -m 0644 $(MAN_FILES) $(DESTDIR)$(MANDIR)/man3)
 
@@ -86,19 +87,19 @@
 	$(Q)mkdir -p $(SHARED_OBJDIR)
 
 $(STATIC_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(STATIC_OBJDIR)
-	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) -D LIBXDP_STATIC=1 -Wall -I../../headers -c $< -o $@
+	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(STATIC_CFLAGS) -Wall -I../../headers -c $< -o $@
 
 $(SHARED_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(SHARED_OBJDIR)
 	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(SHARED_CFLAGS) -Wall -I../../headers -c $< -o $@
 
 XDP_IN_SHARED	:= $(SHARED_OBJDIR)/libxdp.o $(SHARED_OBJDIR)/xsk.o
 
-GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(XDP_IN_SHARED) | \
+GLOBAL_SYM_COUNT = $(shell $(READELF) -s --wide $(XDP_IN_SHARED) | \
 			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
 			   sed 's/\[.*\]//' | \
 			   awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
 			   sort -u | wc -l)
-VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OBJDIR)/libxdp.so | \
+VERSIONED_SYM_COUNT = $(shell $(READELF) --dyn-syms --wide $(OBJDIR)/libxdp.so | \
 			      grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 | sort -u | wc -l)
 
 check: $(CHECK_RULES)
@@ -110,12 +111,12 @@
 		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
 		     "Please make sure all symbols are"	 \
 		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
-		readelf -s --wide $(XDP_IN_SHARED) |			 \
+		$(READELF) -s --wide $(XDP_IN_SHARED) |			 \
 		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
 		    sed 's/\[.*\]//' |					 \
 		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
 		    sort -u > $(OUTPUT)libxdp_global_syms.tmp;		 \
-		readelf --dyn-syms --wide $(OUTPUT)libxdp.so |		 \
+		$(READELF) --dyn-syms --wide $(OUTPUT)libxdp.so |		 \
 		    grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 |		 \
 		    sort -u > $(OUTPUT)libxdp_versioned_syms.tmp; 	 \
 		diff -u $(OUTPUT)libxdp_global_syms.tmp			 \

=== lib/util/Makefile ===
include util.mk

LIB_DIR ?= ..

include $(LIB_DIR)/defines.mk
include $(LIBXDP_DIR)/libxdp.mk

all: $(UTIL_OBJS)

UTIL_SKEL_H = $(UTIL_BPF_OBJS:.bpf.o=.skel.h)

$(UTIL_OBJS): %.o: %.c %.h $(UTIL_SKEL_H) $(LIBMK)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) -Wall -I../../headers -c -o $@ $<

clean:
	$(Q)rm -f $(UTIL_OBJS) $(UTIL_BPF_OBJS) $(UTIL_SKEL_H)

BPF_CFLAGS += -I$(HEADER_DIR) $(ARCH_INCLUDES)

$(UTIL_BPF_OBJS): %.o: %.c $(KERN_USER_H) $(BPF_HEADERS) $(LIBMK)
	$(QUIET_CLANG)$(CLANG) -S \
	    -target $(BPF_TARGET) \
	    -D __BPF_TRACING__ \
	    $(BPF_CFLAGS) \
	    -Wall \
	    -Wno-unused-value \
	    -Wno-pointer-sign \
	    -Wno-compare-distinct-pointer-types \
	    -Werror \
	    -O2 -emit-llvm -c -g -o ${@:.o=.ll} $<
	$(QUIET_LLC)$(LLC) -march=$(BPF_TARGET) -filetype=obj -o $@ ${@:.o=.ll}

$(UTIL_SKEL_H): %.skel.h: %.bpf.o
	$(QUIET_GEN)$(BPFTOOL) gen skeleton $< name ${@:.skel.h=} > $@

=== lib/libxdp/tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
 
-USER_TARGETS := test_xsk_refcnt check_kern_compat test_xdp_frags test_dispatcher_versions
+USER_TARGETS := test_xsk_refcnt check_kern_compat test_xdp_frags test_dispatcher_versions test_link_detach
 BPF_TARGETS := xdp_dispatcher_v1 xdp_pass
 USER_LIBS := -lpthread
 
@@ -10,14 +10,20 @@
 TEST_FILE := ./test-libxdp.sh
 TEST_RUNNER := ./test_runner.sh
 
-USER_C := ${USER_TARGETS:=.c}
-USER_OBJ := ${USER_C:.c=.o}
-BPF_OBJS := $(BPF_TARGETS:=.o)
-
 LIB_DIR := ../..
 LDLIBS += $(USER_LIBS)
 
 include $(LIB_DIR)/defines.mk
+
+ifeq ($(HAVE_CAP_NG),y)
+	USER_TARGETS += test_xsk_non_privileged
+	CFLAGS += $(CAP_NG_CFLAGS)
+	LDLIBS += $(CAP_NG_LDLIBS)
+endif
+
+USER_C := ${USER_TARGETS:=.c}
+USER_OBJ := ${USER_C:.c=.o}
+BPF_OBJS := $(BPF_TARGETS:=.o)
 
 LDFLAGS+=-L$(LIBXDP_DIR)
 ifeq ($(DYNAMIC_LIBXDP),1)

=== debian/changelog ===
xdp-tools (1.4.2-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:20 +1100

xdp-tools (1.4.2-1ubuntu3) noble; urgency=medium

  * No-change rebuild for libpcap t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 14:05:04 +0100

xdp-tools (1.4.2-1ubuntu2) noble; urgency=medium

  * d/rules: fix bpftool detection (LP: #2054095)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Fri, 16 Feb 2024 13:20:28 +0100

xdp-tools (1.4.2-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: Change build dep for bpftool on Ubuntu

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 14 Feb 2024 16:59:02 +0100

xdp-tools (1.4.2-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.4.2'

 -- Luca Boccassi <bluca@debian.org>  Mon, 05 Feb 2024 21:38:35 +0000

xdp-tools (1.4.0-1) unstable; urgency=medium

  * Enable ELF metadata stamping
  * d//rules: Fix discovery of real bpftool binary for Ubuntu
  * Update upstream source from tag 'upstream/1.4.0'
  * Add new symbols for 1.4.0

 -- Luca Boccassi <bluca@debian.org>  Sat, 08 Jul 2023 16:10:01 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Rules-Requires-Root: no
 Build-Depends: clang,
                debhelper-compat (= 13),
+               dh-package-notes,
                libbpf-dev,
                libelf-dev,
                libpcap-dev,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
export FORCE_SYSTEM_LIBBPF=1
export PRODUCTION=1
# For asm/types.h
export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
export BPF_CFLAGS+= -D__MIPSEL__=1
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
# the binary corresponding to runtime kernel version.
#
# We do not know the kernel version being used on the system building
# this package, and in sbuild/container environments uname might not
# even match anything available to the build.
# Gladly for the build we only need the tool to generate skeleton code.
#
# If any /usr/lib/linux-tools-*/bpftool exists, locate the most recent
# version and point to that, otherwise `bpftool` from PATH will be
# used.
find_bpftool_binary = \
	for _bpftool in $$(ls -r /usr/lib/linux-tools/*/bpftool 2>/dev/null); \
		do \
			if [ -x "$$_bpftool" ]; then \
				echo $$_bpftool; \
				break; \
			fi;\
		done

ifneq ($(shell $(find_bpftool_binary)),)
export BPFTOOL=$(shell $(find_bpftool_binary))
endif

%:
	dh $@

# Tests require root and break the testbed
override_dh_auto_test:

=== debian/tests/control ===
Test-Command: /usr/libexec/xdp-tools/run_tests.sh
Restrictions: isolation-machine, needs-root
Depends: xdp-tests, ethtool, iproute2, iputils-ping, netcat-openbsd, tcpdump, tshark

## xdp-tools 1.4.3

=== lib/libxdp/Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 TEMPLATED_SOURCES := xdp-dispatcher.c
 
 CFLAGS += -I$(HEADER_DIR)
-BPF_CFLAGS += -I$(HEADER_DIR)
+BPF_CFLAGS += -I$(HEADER_DIR) $(ARCH_INCLUDES)
 
 
 ifndef BUILD_STATIC_ONLY
@@ -42,7 +42,7 @@
 all: $(STATIC_LIBS) $(SHARED_LIBS) $(XDP_OBJS) $(PC_FILE) check man
 
 clean:
-	$(Q)rm -f $(STATIC_LIBS) $(STATIC_OBJS) $(SHARED_LIBS) $(SHARED_OBJS) $(XDP_OBJS) $(PC_FILE) $(MAN_OBJ) $(TEMPLATED_SOURCES)
+	$(Q)rm -f $(STATIC_LIBS) $(STATIC_OBJS) $(SHARED_LIBS) $(SHARED_OBJS) $(XDP_OBJS) $(PC_FILE) $(MAN_OBJ) $(TEMPLATED_SOURCES) *.ll
 	$(Q)for d in $(SHARED_OBJDIR) $(STATIC_OBJDIR); do \
 		[ -d "$$d" ] && rmdir "$$d"; done || true
 	$(Q)$(MAKE) -C $(TEST_DIR) clean

=== debian/changelog ===
xdp-tools (1.4.3-2ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: Change build dep for bpftool on Ubuntu

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 27 Dec 2024 12:04:15 +0000

xdp-tools (1.4.3-2) unstable; urgency=medium

  * autopkgtest: add mount to the list of dependencies
  * autopkgtest: add allow-stderr to restrictions

 -- Luca Boccassi <bluca@debian.org>  Tue, 24 Dec 2024 07:57:57 +0000

xdp-tools (1.4.3-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: Change build dep for bpftool on Ubuntu
  * Drop Changes:
    - d/rules: fix bpftool detection (LP: #2054095)
      [Fixed in: 1.4.3-1]

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 17 Oct 2024 22:09:06 +0100

xdp-tools (1.4.3-1) unstable; urgency=medium

  * d/rules: fix bpftool detection in Ubuntu
  * d/rules: simply bpftool lookup in Ubuntu
  * Update upstream source from tag 'upstream/1.4.3' (Closes: #1046253,
    #1068532)
  * d/control: bump Standards-Version to 4.7.0, no changes
  * Switch to pkgconf

 -- Luca Boccassi <bluca@debian.org>  Fri, 09 Aug 2024 11:04:36 +0100

=== debian/tests/control ===
Test-Command: /usr/libexec/xdp-tools/run_tests.sh
Restrictions: isolation-machine, needs-root, allow-stderr
Depends: xdp-tests, ethtool, iproute2, iputils-ping, netcat-openbsd, tcpdump, tshark, mount

## xdp-tools 1.5.0

=== lib/libxdp/Makefile ===
--- 
+++ 
@@ -131,7 +131,7 @@
 	$(QUIET_M4)$(M4) $(DEFINES) $< > $@ || ( ret=$$?; rm -f $@; exit $$ret )
 
 $(EMBEDDED_XDP_OBJS): %.embed.o: %.o
-	$(QUIET_GEN)$(LD) -r -b binary -o $@ -z noexecstack --format=binary $<
+	$(QUIET_CC)$(CC) -r -nostdlib -Wl,-z,noexecstack,--format=binary -o $@ $<
 	$(Q)$(OBJCOPY)  --rename-section .data=.rodata,alloc,load,readonly,data,contents $@
 
 $(XDP_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK)

=== debian/changelog ===
xdp-tools (1.5.0-2ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: Change build dep for bpftool on Ubuntu

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 15 Jan 2025 20:44:38 +0000

xdp-tools (1.5.0-2) unstable; urgency=medium

  * d/t/control: add socat dependency for new tests
  * Backport patch to fix autopkgtest

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Jan 2025 22:38:59 +0000

xdp-tools (1.5.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.0'
  * Install new xdp-forward tool
  * Update symbols file for 1.5.0
  * Patch makefile to fix blhc warnings

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Jan 2025 10:28:53 +0000

## xdp-tools 1.5.1

=== lib/libxdp/Makefile ===
--- 
+++ 
@@ -131,7 +131,7 @@
 	$(QUIET_M4)$(M4) $(DEFINES) $< > $@ || ( ret=$$?; rm -f $@; exit $$ret )
 
 $(EMBEDDED_XDP_OBJS): %.embed.o: %.o
-	$(QUIET_CC)$(CC) -r -nostdlib -Wl,-z,noexecstack,--format=binary -o $@ $<
+	$(QUIET_CC)$(CC) -r -nostdlib -Wl,-z,noexecstack,--format=binary $(LDFLAGS) -o $@ $<
 	$(Q)$(OBJCOPY)  --rename-section .data=.rodata,alloc,load,readonly,data,contents $@
 
 $(XDP_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK)

=== lib/util/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) -Wall -I../../headers -c -o $@ $<
 
 clean:
-	$(Q)rm -f $(UTIL_OBJS) $(UTIL_BPF_OBJS) $(UTIL_SKEL_H)
+	$(Q)rm -f $(UTIL_OBJS) $(UTIL_BPF_OBJS) $(UTIL_SKEL_H) *.ll
 
 BPF_CFLAGS += -I$(HEADER_DIR) $(ARCH_INCLUDES)

=== debian/changelog ===
xdp-tools (1.5.1-1ubuntu2) plucky; urgency=medium

  * d/p/lp-2098005-*-Fix-incorrect-setsockopt-xdp_umem_reg-size.patch
    (LP: #2098005).
  * d/rules: Workaround for FTBFS caused by change in behavior in LLVM
    toolchain (LP: #2103416).
  * d/control: Use bpftool as dependency directly now that it has moved
    to a separate binary package (LP: #2007308).
  * d/xdp-tools.install.riscv64: Skip binaries missing due to no bpftool
    on riscv64 (LP: #2106091).

 -- Frode Nordahl <fnordahl@ubuntu.com>  Thu, 03 Apr 2025 05:33:23 +0000

xdp-tools (1.5.1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: Change build dep for bpftool on Ubuntu
  * New Changes:
    - Use 'find -L' to find bpftool from symlinks.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 07 Feb 2025 18:36:43 +0000

xdp-tools (1.5.1-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.1'
  * Drop all patches, merged upstream

 -- Luca Boccassi <bluca@debian.org>  Sat, 18 Jan 2025 02:29:30 +0000

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 XSBC-Original-Maintainer: Luca Boccassi <bluca@debian.org>
 Rules-Requires-Root: no
 Build-Depends: clang,
+               bpftool [!riscv64],
                debhelper-compat (= 13),
                dh-package-notes,
                libbpf-dev,
                libelf-dev,
                libpcap-dev,
-               linux-tools-generic,
                llvm,
-               pkg-config,
+               pkgconf,
                zlib1g-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/xdp-project/xdp-tools
 Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
 Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,8 @@
 export PRODUCTION=1
 # For asm/types.h
 export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
+# Workaround for LP: #2103416
+export BPF_CFLAGS+=-Wno-unused-command-line-argument
 ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
 export BPF_CFLAGS+= -D__MIPSEL__=1
 endif
@@ -28,20 +30,12 @@
 # even match anything available to the build.
 # Gladly for the build we only need the tool to generate skeleton code.
 #
-# If any /usr/lib/linux-tools-*/bpftool exists, locate the most recent
+# If any /usr/lib/linux-tools/*/bpftool exists, locate the most recent
 # version and point to that, otherwise `bpftool` from PATH will be
 # used.
-find_bpftool_binary = \
-	for _bpftool in $$(ls -r /usr/lib/linux-tools/*/bpftool 2>/dev/null); \
-		do \
-			if [ -x "$$_bpftool" ]; then \
-				echo $$_bpftool; \
-				break; \
-			fi;\
-		done
-
-ifneq ($(shell $(find_bpftool_binary)),)
-export BPFTOOL=$(shell $(find_bpftool_binary))
+bpftool_binary := $(shell find -L /usr/lib/linux-tools/ -name 'bpftool' -perm /u=x 2>/dev/null | sort | head -n1)
+ifneq ($(bpftool_binary),)
+export BPFTOOL=$(bpftool_binary)
 endif
 
 %:

## xdp-tools 1.5.2

=== debian/changelog ===
xdp-tools (1.5.2-1) unstable; urgency=medium

  * Team upload.

  [ Frode Nordahl ]
  * Update upstream source from tag 'upstream/1.5.2'

  [ Sudip Mukherjee ]
  * d/rules: Use 'find -L' to find bpftool from symlinks in Ubuntu.

 -- Frode Nordahl <fnordahl@ubuntu.com>  Wed, 19 Feb 2025 12:39:58 +0000

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,6 @@
 export PRODUCTION=1
 # For asm/types.h
 export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
-# Workaround for LP: #2103416
-export BPF_CFLAGS+=-Wno-unused-command-line-argument
 ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
 export BPF_CFLAGS+= -D__MIPSEL__=1
 endif

## xdp-tools 1.5.3

=== debian/changelog ===
xdp-tools (1.5.3-2) unstable; urgency=medium

  * Team upload.
  * d/control: Set minimum bpftool build dependency version.
  * d/rules: Drop Ubuntu specific workaround for bpftool.

 -- Frode Nordahl <fnordahl@ubuntu.com>  Mon, 17 Mar 2025 11:04:16 +0000

xdp-tools (1.5.3-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.3'

 -- Luca Boccassi <bluca@debian.org>  Tue, 11 Mar 2025 12:26:10 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: xdp-tools
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Luca Boccassi <bluca@debian.org>
+Maintainer: Luca Boccassi <bluca@debian.org>
 Rules-Requires-Root: no
-Build-Depends: clang,
-               bpftool [!riscv64],
+Build-Depends: bpftool (>= 7.5.0~),
+               clang,
                debhelper-compat (= 13),
                dh-package-notes,
                libbpf-dev,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
export FORCE_SYSTEM_LIBBPF=1
export PRODUCTION=1
# For asm/types.h
export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
export BPF_CFLAGS+= -D__MIPSEL__=1
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

%:
	dh $@

# Tests require root and break the testbed
override_dh_auto_test:

## xdp-tools 1.5.4

=== debian/changelog ===
xdp-tools (1.5.4-1) unstable; urgency=medium

  [ Frode Nordahl ]
  * d/rules: add workaround for clang 20 issue

  [ Luca Boccassi ]
  * Update upstream source from tag 'upstream/1.5.4'
  * d/control: bump Standards-Version to 4.7.2, no changes
  * d/copyright: use GPL URL instead of old FSF postal address

 -- Luca Boccassi <bluca@debian.org>  Wed, 30 Apr 2025 10:49:11 +0100

=== debian/tests/control ===
Test-Command: /usr/libexec/xdp-tools/run_tests.sh
Restrictions: isolation-machine, needs-root, allow-stderr
Depends: xdp-tests, ethtool, iproute2, iputils-ping, netcat-openbsd, tcpdump, tshark, mount, socat

## xdp-tools 1.5.5

=== debian/changelog ===
xdp-tools (1.5.5-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.5'

 -- Luca Boccassi <bluca@debian.org>  Sun, 10 Aug 2025 11:42:04 +0100

## xdp-tools 1.5.6

=== xdp-trafficgen/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS  := xdp_trafficgen.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-trafficgen
USER_TARGETS := xdp-trafficgen
MAN_PAGE := xdp-trafficgen.8
EXTRA_DEPS := xdp-trafficgen.h
USER_LIBS     = -lpthread
TEST_FILE := tests/test-xdp-trafficgen.sh

LIB_DIR = ../lib

include $(LIB_DIR)/common.mk

=== lib/libxdp/Makefile ===
--- 
+++ 
@@ -135,17 +135,7 @@
 	$(Q)$(OBJCOPY)  --rename-section .data=.rodata,alloc,load,readonly,data,contents $@
 
 $(XDP_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK)
-	$(QUIET_CLANG)$(CLANG) -S \
-	    -target $(BPF_TARGET) \
-	    -D __BPF_TRACING__ \
-	    $(BPF_CFLAGS) \
-	    -Wall \
-	    -Wno-unused-value \
-	    -Wno-pointer-sign \
-	    -Wno-compare-distinct-pointer-types \
-	    -Werror \
-	    -O2 -emit-llvm -c -g -o ${@:.o=.ll} $<
-	$(QUIET_LLC)$(LLC) -march=$(BPF_TARGET) -filetype=obj -o $@ ${@:.o=.ll}
+	$(QUIET_CLANG)$(CLANG) -target $(BPF_TARGET) $(BPF_CFLAGS) -O2 -c -g -o $@ $<
 
 .PHONY: man
 ifeq ($(EMACS),)

=== lib/libxdp/tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
 
-USER_TARGETS := test_xsk_refcnt check_kern_compat test_xdp_frags test_dispatcher_versions test_link_detach
+USER_TARGETS := test_xsk_refcnt check_kern_compat test_xdp_frags test_dispatcher_versions test_link_detach test_xsk_umem_flags
 BPF_TARGETS := xdp_dispatcher_v1 xdp_pass
 USER_LIBS := -lpthread
 
@@ -70,17 +70,7 @@
 	 $< $(LDLIBS)
 
 $(BPF_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK) $(EXTRA_DEPS)
-	$(QUIET_CLANG)$(CLANG) -S \
-	    -target $(BPF_TARGET) \
-	    -D __BPF_TRACING__ \
-	    $(BPF_CFLAGS) \
-	    -Wall \
-	    -Wno-unused-value \
-	    -Wno-pointer-sign \
-	    -Wno-compare-distinct-pointer-types \
-	    -Werror \
-	    -O2 -emit-llvm -c -g -o ${@:.o=.ll} $<
-	$(QUIET_LLC)$(LLC) -march=$(BPF_TARGET) -filetype=obj -o $@ ${@:.o=.ll}
+	$(QUIET_CLANG)$(CLANG) -target $(BPF_TARGET) $(BPF_CFLAGS) -O2 -c -g -o $@ $<
 
 run: all
 	$(Q)env CC="$(CC)" CFLAGS="$(CFLAGS) $(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDLIBS="$(LDLIBS)" V=$(V) $(TEST_RUNNER) $(TEST_FILE) $(RUN_TESTS)

=== debian/changelog ===
xdp-tools (1.5.6-1~cloud0) noble-flamingo; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Guillaume Boutry <guillaume.boutry@canonical.com>  Mon, 06 Oct 2025 08:09:24 +0000

xdp-tools (1.5.6-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.6'

 -- Luca Boccassi <bluca@debian.org>  Mon, 18 Aug 2025 11:27:47 +0100

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,17 @@
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
 Rules-Requires-Root: no
-Build-Depends: bpftool (>= 7.5.0~),
-               clang,
+Build-Depends: clang,
                debhelper-compat (= 13),
                dh-package-notes,
                libbpf-dev,
                libelf-dev,
                libpcap-dev,
+               linux-tools-generic,
                llvm,
                pkgconf,
                zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/xdp-project/xdp-tools
 Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
 Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git
